#line 1 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/ARM/StereoAmp_click_ARM.c"
#line 1 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
#line 1 "c:/users/branislav.marton/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 79 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
char* gain_text[] = {
 "  -80dB",
 "  -54dB",
 "-40.5dB",
 "-34.5dB",
 "  -30dB",
 "  -27dB",
 "  -24dB",
 "  -21dB",
 "  -18dB",
 "  -15dB",
 "-13.5dB",
 "  -12dB",
 "-10.5dB",
 "   -9dB",
 " -7.5dB",
 "   -6dB",
 " -4.5dB",
 "   -3dB",
 " -1.5dB",
 "    0dB",
 "  1.5dB",
 "    3dB",
 "  4.5dB",
 "    6dB",
 "  7.5dB",
 "    9dB",
 " 10.5dB",
 "   12dB",
 " 13.5dB",
 "   15dB",
 " 16.5dB",
 "   18dB"
};
#line 47 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/ARM/StereoAmp_click_ARM.c"
typedef struct volume_widget {
 uint8_t active;
 char label;
 uint16_t x;
 uint16_t y;
 uint8_t value;
} volume_widget;
#line 59 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/ARM/StereoAmp_click_ARM.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;


uint8_t volume_control_L = 15;
uint8_t volume_control_R = 15;

uint8_t buttonstate_right = 0xFF;
uint8_t buttonstate_left = 0xFF;
uint8_t buttonstate_up = 0xFF;
uint8_t buttonstate_down = 0xFF;

uint8_t active_left_control = 0xFF;


volume_widget volume_widget_L;
volume_widget volume_widget_R;
#line 85 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/ARM/StereoAmp_click_ARM.c"
void Write_Text(const char* text, uint8_t x, uint8_t y) {
 TFT_Set_Font(TFT_defaultFont, CL_GRAY, FO_HORIZONTAL);
 TFT_Write_Text(text, x, y );
}

void Erase_Text(const char* text, uint8_t x, uint8_t y) {
 TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
 TFT_Write_Text(text, x, y );
}

void Volume_Widget_Init(volume_widget* widget) {
 uint8_t i;
 uint16_t x = widget->x;
 uint16_t y = widget->y;

 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Set_Pen(CL_BLACK, 0);

 TFT_Rectangle(x, y, x + 198, y + 15);
 TFT_Set_Font(TFT_defaultFont, CL_GRAY, FO_HORIZONTAL);

 TFT_Write_Text(gain_text[widget->value], x + 28, y );
 TFT_Write_Char(widget->label, x + 18, y );

 if(widget->active) {
 TFT_Set_Brush(1, CL_GRAY, 0, 0, 0, 0);
 TFT_Rectangle(x + 5, y + 5, x + 10, y + 10);
 }

 TFT_Set_Pen(CL_GRAY, 1);
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Rectangle(x + 97, y, x + 195, y + 15);

 TFT_Set_Pen(CL_GRAY, 2);
 TFT_V_Line(y + 2, y + 13, x + 100);
 for(i = 1; i <= widget->value; i++) {
 TFT_V_Line(y + 2, y + 13, x + 100 + i * 3);
 }

}


void Write_Amp_Reg(uint8_t amp_addr, uint8_t reg_addr, uint8_t reg_data) {
 char data_write = (reg_addr &  0b11100000 ) | (reg_data &  0b00011111 );
 delay_ms(1);
 I2C1_Start();
 I2C1_Write(amp_addr, &data_write, 1, END_MODE_STOP);
}


void MCU_Init() {

 GPIO_Digital_Output(&GPIOB_ODR, _GPIO_PINMASK_6 |_GPIO_PINMASK_7);
 GPIOB_ODR = 0xC0;
 Delay_ms(300);
 GPIOB_ODR = 0x00;
 Delay_ms(300);

 GPIO_Digital_Input(&GPIOA_IDR, _GPIO_PINMASK_6);
 GPIO_Digital_Input(&GPIOB_IDR, _GPIO_PINMASK_5);
 GPIO_Digital_Input(&GPIOD_IDR, _GPIO_PINMASK_2 | _GPIO_PINMASK_4);


 I2C1_Init_Advanced( 200000 , &_GPIO_MODULE_I2C1_PB67);

 Delay_ms(800);

 TFT_Init_ILI9341_8bit(320, 240);
 TFT_Fill_Screen(CL_BLACK);
}

void StereoAmp_Init() {

 Write_Amp_Reg( 0XFC ,  0b00000000 ,  0b00010000  |  0b00000100 );
 Write_Amp_Reg( 0XFD ,  0b00000000 ,  0b00010000  |  0b00000100 );


 Write_Amp_Reg( 0XFC ,  0b01100000 , volume_control_L);
 Write_Amp_Reg( 0XFD ,  0b01100000 , volume_control_R);


 Write_Amp_Reg( 0XFC ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );
 Write_Amp_Reg( 0XFD ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );


 Write_Amp_Reg( 0XFC ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );
 Write_Amp_Reg( 0XFD ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );
}


void Set_Volume(char amp_addr, char value) {
 Write_Amp_Reg(amp_addr,  0b01100000 , value);
}

uint8_t Button_Pressed(unsigned int *port, unsigned int pin, uint8_t* state) {
 uint8_t new_state = Button(port, pin, 1, 1);
 if(*state == 0xFF && new_state == 0x00 ) {
 *state = new_state;
 return 0xFF;
 }

 *state = new_state;
 return 0x00;
}

uint8_t Button_Hold(unsigned int *port, unsigned int pin, uint8_t* state) {
 uint8_t new_state = Button(port, pin, 1, 1);
 if(*state == 0x00 && new_state == 0x00 ) {
 *state = new_state;
 return 0xFF;
 }

 *state = new_state;
 return 0x00;
}

void Volume_Widget_Update(volume_widget* widget, uint8_t value, uint8_t active) {
 uint8_t i;
 uint16_t x = widget->x;
 uint16_t y = widget->y;

 if(value != widget->value) {
 Erase_Text(gain_text[widget->value], x + 28, y );

 if(value < widget->value) {
 TFT_Set_Pen(CL_BLACK, 2);
 TFT_V_Line(y + 2, y + 13, x + 100 + widget->value * 3);
 }

 if(value > widget->value) {
 TFT_Set_Pen(CL_GRAY, 2);
 TFT_V_Line(y + 2, y + 13, x + 100 + value * 3);
 }

 widget->value = value;

 Write_Text(gain_text[widget->value], x + 28, y );
 }

 if(widget->active != active) {
 TFT_Set_Pen(CL_BLACK, 0);
 if(active)
 TFT_Set_Brush(1, CL_GRAY, 0, 0, 0, 0);
 else
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);

 TFT_Rectangle(x + 5, y + 5, x + 10, y + 10);
 widget->active = active;
 }
}

uint8_t Clamp(int16_t value, int16_t min, int16_t max) {
 if(value < min) return min;
 if(value > max) return max;

 return value;
}


void main() {
 MCU_Init();

 Write_Text("Initialising...", 10, 20 );
 StereoAmp_Init();

 Erase_Text("Initialising...", 10, 20 );

 Write_Text("StereoAmp Click - Example", 10, 20 );
 Write_Text("Note: Use Joystic for controlling volume.", 10, 120 );

 volume_widget_L.active = 0xFF;
 volume_widget_L.label = 'R';
 volume_widget_L.x = 10;
 volume_widget_L.y = 50;
 volume_widget_L.value = volume_control_L;

 volume_widget_R.active = 0x00;
 volume_widget_R.label = 'L';
 volume_widget_R.x = 10;
 volume_widget_R.y = 75;
 volume_widget_R.value = volume_control_R;

 Volume_Widget_Init(&volume_widget_L);
 Volume_Widget_Init(&volume_widget_R);

 while(1) {
 if(Button_Hold(&GPIOA_IDR, 6, &buttonstate_right)) {
 if(active_left_control) {
 volume_control_L = Clamp(volume_control_L + 1, 0, 31);
 Set_Volume( 0XFC , volume_control_L);
 } else {
 volume_control_R = Clamp(volume_control_R + 1, 0, 31);
 Set_Volume( 0XFD , volume_control_R);
 }
 }

 if(Button_Hold(&GPIOD_IDR, 2, &buttonstate_left)) {
 if(active_left_control) {
 volume_control_L = Clamp(volume_control_L - 1, 0, 31);
 Set_Volume( 0XFC , volume_control_L);
 } else {
 volume_control_R = Clamp(volume_control_R - 1, 0, 31);
 Set_Volume( 0XFD , volume_control_R);
 }
 }

 if(Button_Pressed(&GPIOD_IDR, 4, &buttonstate_up))
 active_left_control = 0xFF;

 if(Button_Pressed(&GPIOB_IDR, 5, &buttonstate_down))
 active_left_control = 0x00;

 Volume_Widget_Update(&volume_widget_L, volume_control_L, active_left_control);
 Volume_Widget_Update(&volume_widget_R, volume_control_R, ~active_left_control);

 Delay_ms( 5 );
 }
}
